<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="会员ID" prop="userId">
        <el-input v-model="formData.userId" placeholder="请输入会员ID" />
      </el-form-item>
      <el-form-item label="提现方式" prop="withdrawalType">
        <el-select v-model="formData.withdrawalType" placeholder="请选择提现方式">
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.MEMBER_WITHDRAWAL_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="提现金额" prop="amount">
        <el-input v-model="formData.amount" placeholder="请输入提现金额" />
      </el-form-item>
      <el-form-item label="币种" prop="currency">
        <el-input v-model="formData.currency" placeholder="请输入币种" />
      </el-form-item>
      <el-form-item label="提现状态" prop="status">
        <el-radio-group v-model="formData.status">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.MEMBER_WITHDRAWAL_STATUS)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="申请日期" prop="requestDate">
        <el-date-picker
          v-model="formData.requestDate"
          type="date"
          value-format="x"
          placeholder="选择申请日期"
        />
      </el-form-item>
      <el-form-item label="审批日期" prop="processedDate">
        <el-date-picker
          v-model="formData.processedDate"
          type="date"
          value-format="x"
          placeholder="选择审批日期"
        />
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input v-model="formData.remark" placeholder="请输入备注" />
      </el-form-item>
      <el-form-item label="手续费" prop="fee">
        <el-input v-model="formData.fee" placeholder="请输入手续费" />
      </el-form-item>
      <el-form-item label="净提现金额" prop="netAmount">
        <el-input v-model="formData.netAmount" placeholder="请输入净提现金额" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { DICT_TYPE, getIntDictOptions, getStrDictOptions } from '@/utils/dict'
import * as WithdrawalApi from '@/api/member/withdrawal'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  userId: undefined,
  withdrawalType: undefined,
  amount: undefined,
  currency: undefined,
  status: undefined,
  requestDate: undefined,
  processedDate: undefined,
  remark: undefined,
  fee: undefined,
  netAmount: undefined
})
const formRules = reactive({
  userId: [{ required: true, message: '会员ID不能为空', trigger: 'blur' }],
  withdrawalType: [{ required: true, message: '提现方式不能为空', trigger: 'change' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await WithdrawalApi.getWithdrawal(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as WithdrawalApi.WithdrawalVO
    if (formType.value === 'create') {
      await WithdrawalApi.createWithdrawal(data)
      message.success(t('common.createSuccess'))
    } else {
      await WithdrawalApi.updateWithdrawal(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    userId: undefined,
    withdrawalType: undefined,
    amount: undefined,
    currency: undefined,
    status: undefined,
    requestDate: undefined,
    processedDate: undefined,
    remark: undefined,
    fee: undefined,
    netAmount: undefined
  }
  formRef.value?.resetFields()
}
</script>
